package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.LocalVariableInstruction;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.Visitor;
import org.apache.bcel.util.ByteSequence;

public class IINC extends LocalVariableInstruction {
  private boolean wide;
  
  private int c;
  
  IINC() {}
  
  public IINC(int n, int c) {
    setOpcode((short)132);
    setLength(3);
    setIndex(n);
    setIncrement(c);
  }
  
  public void accept(Visitor v) {
    v.visitLocalVariableInstruction(this);
    v.visitIINC(this);
  }
  
  public void dump(DataOutputStream out) throws IOException {
    if (this.wide)
      out.writeByte(196); 
    out.writeByte(getOpcode());
    if (this.wide) {
      out.writeShort(getIndex());
      out.writeShort(this.c);
    } else {
      out.writeByte(getIndex());
      out.writeByte(this.c);
    } 
  }
  
  public final int getIncrement() {
    return this.c;
  }
  
  public Type getType(ConstantPoolGen cp) {
    return Type.INT;
  }
  
  protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
    this.wide = wide;
    if (wide) {
      setLength(6);
      setIndexOnly(bytes.readUnsignedShort());
      this.c = bytes.readShort();
    } else {
      setLength(3);
      setIndexOnly(bytes.readUnsignedByte());
      this.c = bytes.readByte();
    } 
  }
  
  public final void setIncrement(int c) {
    this.c = c;
    setWide();
  }
  
  public final void setIndex(int n) {
    if (n < 0)
      throw new ClassGenException("Negative index value: " + n); 
    setIndexOnly(n);
    setWide();
  }
  
  private void setWide() {
    this.wide = (getIndex() > 255);
    if (this.c > 0) {
      this.wide = (this.wide || this.c > 127);
    } else {
      this.wide = (this.wide || this.c < -128);
    } 
    if (this.wide) {
      setLength(6);
    } else {
      setLength(3);
    } 
  }
  
  public String toString(boolean verbose) {
    return super.toString(verbose) + " " + this.c;
  }
}
